﻿
namespace CANSim
{
    class BitPositions
    {
        public const int bitPosKL15 = 7;
        public const int bitPosKLS = 6;
        public const int bitPosSleep = 4;
        public const int bitPosBacklight = 2;
        public const int bitPosPDC = 1;
        public const int bitPosREV = 0;
    }
    class SerialPortParameters
    {
        public const System.IO.Ports.Parity parity = System.IO.Ports.Parity.Odd;
        public const System.IO.Ports.StopBits stopBits = System.IO.Ports.StopBits.One;
        public const int baudrate = 115200;
        public const int modbusAddress = 1;
    }
    class RegiestersAdresses
    {
        public enum InputRegisters
        {
            DipSwitchesSetting = 30000,
            BacklightKnobPosition = 30001,
            SteeringKnobPosition = 30002,
            P5KnobPosition = 30003,
            P6KnobPosition = 30004,
            RpmKnobPosition = 30005,
            SpeedKnobPosition = 30006,
            PowerInputVoltage = 30007,
            KL30Voltage = 30008,
            SwitchesPosition = 30018,
            SerialNumber = 30020,
            FwVersion = 30021
        }

        public enum HoldingRegisters
        {
            DeviceConfiguration = 40000,
            BacklightKnobPosition = 40001,
            SteeringKnobPosition = 40002,
            P5KnobPosition = 40003,
            P6KnobPosition = 40004,
            RpmKnobPosition = 40005,
            SpeedKnobPosition = 40006,
            SwitchesPosition = 40020
        }
    }
    class Knob
    {
        public const int SpeedMaxValue = 240;
        public const int RpmMaxValue = 8000;
        public const int BacklightMaxValue = 100;
        public const int SteeringMaxValue = 8;
        public const int P5MaxValue = 100;
        public const int P6MaxValue = 100;
        public Knob(int maxValue) => this.maxValue = maxValue;
        protected int maxValue;
        public const int knobMax = 0x0FFF;
        public int Knob2Value(int knobPosition)
        {
            //convert 12bit value from device to physical value
            return knobPosition * maxValue / knobMax;
        }
        public int Value2Knob(int value)
        {
            //convert physical value to 12 bit value to device
            return value * knobMax / maxValue;
        }
    }
}

